'''
Lab 2 - Boot Camp

This lab is designed to practice python basics: native variable types,
lists, for loops, while loops, and control flow statements.
    1. Backward Numbers.
    2. Summing Cubes.
    3. Palindrome Checker.
    4. Don't Go Negative.
    5. Art Contest.

'''
import random
import numpy as np

def backward_numbers():
    '''
    Print numbers 1 to 10, backwards.
    '''
    for index in range(10, 0, -1):
        print(index)

def summing_cubes(max_no: int):
    '''
    Returns the summation of 1^3 to n^3.
    '''
    result = 0
    for index in range(1, max_no+1):
        result += index**3
    return result

def summing_cubes_alternative(max_no: int):
    '''
    Returns the summation of 1^3 to n^3, using the numpy class.
    '''
    return np.sum(np.array(range(1, max_no+1))**3)

def palindrome_checker(text: str):
    '''
    Returns True if word is a palindrome; False otherwise.
    '''
    for index in range(0, int(len(text)/2)):
        if text[index] != text[-(index+1)]:
            return False
    return True

def dont_go_negative():
    '''
    Prints the winner of a round of the "Don't Go Negative" game, which
    entails two players each taking turns rolling a die. If the die roll
    is positive, the player's score is reduced by the die roll; otherwise,
    the player's score is increased by that much.
    '''

    # starting scores
    player1 = 10
    player2 = 10

    turn = 1 # who's turn it is, toggles between player 1 (1) & player 2 (-1)

    # continue game while scores are positive
    while (player1 > 0) and (player2 > 0):

        # one player rolls dice
        dice_roll = random.randint(1,6)
        if dice_roll % 2 == 0: # if dice roll is even, make negative
            dice_roll = dice_roll * -1

        # add dice roll to whomever's turn it was
        if turn == 1:
            player1 += dice_roll
        else:
            player2 += dice_roll

        turn = turn * -1 # toggle back between player 1 & 2

    # determine & print out winner
    if player2 > player1:
        return "Player 2 wins!"
    return "Player 1 wins!"

def make_art(size: int = 10):
    '''
    Creates "A Random ASCII-Ornamented Christmas Tree" whose last
    row has size (int) number of characters, not including in between
    spaces.
    '''
    for outer in range(0, size):
        for _ in range(size, outer, -1):
            print(end=' ')
        for _ in range(0, outer + 1):
            print(str(chr(random.randint(20,1000))), end = ' ')
        print("")

def make_art_alternative(size: int = 10):
    '''
    Prints the numbers 1 to size with no front white spacing.
    '''
    for outer in range(0, size):
        for inner in range(0, outer + 1):
            print(str(inner), end = ' ')
        print("")


if __name__ == "__main__":

    print("Task 1: Backward Numbers")
    backward_numbers()

    print("\nTask 2: Summing Cubes")
    for i in range(1, 4):
        print("n=" + str(i)+ "; answer=" + str(summing_cubes(i)))

    print("\nTask 2: Summing Cubes, Alternative Method")
    for i in range(1, 4):
        print("n=" + str(i)+ "; answer=" + str(summing_cubes_alternative(i)))

    print("\nTask 3: Palindrome Checker")
    for word in ["radar", "abccba", "palindrome", "integer"]:
        print("Is " + word + " a palindrome? "+ str(palindrome_checker(word)))

    print("\nTask 4: Don't Go Negative")
    for i in range(1, 11):
        print("Round " + str(i)+ ": " + dont_go_negative())

    print("\nTask 5: Art Contest")
    make_art(10)

    print("\nTask 5: Art Contest, Alternative Method")
    make_art_alternative(10)
